/**
 * Copyright (c) 2009 Jeremy Stribling, Yair Sovran, Irene Zhang, 
 *                    Xavid Pretzer, Jinyang Li, Frans Kaashoek, Robert Morris,
 *     		      Massachusetts Institute of Technology,
 * 		      New York University
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#ifndef __IDENT_UTIL_H__
#define __IDENT_UTIL_H__

#include <string>
#include <pwd.h>
#include <unistd.h>

// users are uniquely std::stringified by a name of at most len MAX_IDENT_LENGTH
// that does not contain any chars in the string INVALID_IDENT_CHARACTERS
#define MAX_IDENT_LENGTH 64
extern const long PW_MAX_NAME;
// Needed to use MAX_IDENT_LENGTH as a field width specifier
#define _QUOTE(x) #x
#define QUOTE(x) _QUOTE(x)
// These characters are used to terminate/separate things
// =,., and / are used in cues, and , is used in metadata.
// Whitespace is just dumb
#define INVALID_IDENT_CHARACTERS "=,./ \t\n"

std::string get_pwnam_from_uid( uid_t u);
std::string current_username();

#endif
